#include<iostream>
#include<algorithm>
using namespace std;
int S,N,a[2000],b[20000];
int main(){
    int k=0,r,l;
    cin>>S>>N;
    for(int i=0;i<N;i++){
        cin>>a[i];
    }
    sort(a,a+N);
    for(int i=1;i<=S;i++){
        b[i]=S+1;
        if(a[k]==i){
            b[i]=1;
            k++;
        }
        else{
            r=1;
            l=i-1;
            while(l>=r){
                if(b[i]>b[r]+b[l]){
                    b[i]=b[r]+b[l];

                }
                r++;
                l--;
            }
        }
    }
    cout<<b[S];
return 0;
}
